## ntirpc 5.8

=== CMakeLists.txt ===
# New TI-RPC  Cmake

# Current version as of Fedora 16.  Not tested with earlier.

cmake_minimum_required(VERSION 2.6.3)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")

# Add maintainer mode for (mainly) strict builds

include(${CMAKE_SOURCE_DIR}/cmake/maintainer_mode.cmake)

project(NTIRPC C)

# version numbers
set(NTIRPC_MAJOR_VERSION 5)
# This is .0 for a release, .N for a stable branch, blank for development
set(NTIRPC_MINOR_VERSION .8)
# -something for dev releases
set(NTIRPC_VERSION_EXTRA )
set(VERSION_COMMENT
  "Full-duplex and bi-directional ONC RPC on TCP."
)
# version string used for packaging
set(NTIRPC_VERSION
  "${NTIRPC_MAJOR_VERSION}${NTIRPC_MINOR_VERSION}${NTIRPC_VERSION_EXTRA}")
set(NTIRPC_VERSION_BASE
  "${NTIRPC_MAJOR_VERSION}${NTIRPC_MINOR_VERSION}")
# Up scope for embedding in ganesha
set(NTIRPC_VERSION_EMBED "${NTIRPC_VERSION}" PARENT_SCOPE)
set(NTIRPC_VERSION_BASE_EMBED "${NTIRPC_VERSION_BASE}" PARENT_SCOPE)
set(NTIRPC_VERSION_EXTRA_EMBED "${NTIRPC_VERSION_EXTRA}" PARENT_SCOPE)
set(NTIRPC_ABI_EMBED "${NTIRPC_MAJOR_VERSION}${NTIRPC_MINOR_VERSION}" PARENT_SCOPE)

set( PACKNAME "${NTIRPC_VERSION}" )

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Install destination, if built standalone
get_property(USE_LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if (USE_LIB64)
	set(LIB_INSTALL_DIR lib64 CACHE PATH
		"Specify name of libdir inside install path")
else (USE_LIB64)
	set(LIB_INSTALL_DIR lib CACHE PATH
		"Specify name of libdir inside install path")
endif (USE_LIB64)

set(SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES})
set(BINARY_LIBRARIES ${BINARY_LIBRARIES})

include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC _GIT_HEAD_COMMIT)
git_describe(_GIT_DESCRIBE)

# Allow overriding of prefix
if (OVERRIDE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX ${OVERRIDE_INSTALL_PREFIX} CACHE PATH
    "Install prefix" FORCE)
endif(OVERRIDE_INSTALL_PREFIX)
message(STATUS "OVERRIDE_INSTALL_PREFIX = ${OVERRIDE_INSTALL_PREFIX}")

# Set default base directory
set(NTIRPC_BASE_DIR ${PROJECT_SOURCE_DIR} CACHE
  PATH "Path to base source directory of NTIRPC")

# Build configure options

option (USE_GSS "enable RPCSEC_GSS support" ON)
if (USE_GSS)
  find_package(Krb5 REQUIRED gssapi)
  if(KRB5_FOUND)
    set(HAVE_KRB5 ON)
    set(_HAVE_GSSAPI ON)
  else(KRB5_FOUND)
    set(USE_GSS OFF)
  endif(KRB5_FOUND)
endif (USE_GSS)

option(USE_RPC_RDMA "platform supports RDMA" OFF)
if (USE_RPC_RDMA)
  find_package(RDMA REQUIRED)
  include_directories(${RDMA_INCLUDE_DIR})
  set(SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES} ${RDMA_LIBRARY})
endif(USE_RPC_RDMA)

# MSPAC support -lwbclient link flag
option(_MSPAC_SUPPORT "enable mspac Winbind support" OFF)

option(USE_PROFILE "Build with gperf profiling" OFF)
if (USE_PROFILE)
  find_package(Gperftools)
  if(GPERFTOOLS_FOUND)
    set(BINARY_LIBRARIES ${BINARY_LIBRARIES} ${GPERFTOOLS_LIBRARIES})
  else(GPERFTOOLS_FOUND)
    message(WARNING "Couldn't find gperftools. Disabling USE_PROFILE")
    set(USE_PROFILE OFF)
  endif(GPERFTOOLS_FOUND)
endif(USE_PROFILE)

option(USE_LTTNG "Enable LTTng tracing" OFF)
if(USE_LTTNG)
  # Set LTTNG_PATH_HINT on the command line
  # if your LTTng is not in a standard place
  find_package(LTTng REQUIRED)
  if(LTTNG_FOUND)
    include_directories(${LTTNG_INCLUDE_DIR})
    set(USE_LTTNG_NTIRPC ON)
    set(BINARY_LIBRARIES ${BINARY_LIBRARIES} ntirpc_lttng)
  else(LTTNG_FOUND)
    message(WARNING "LTTng libraries not found. Disabling USE_LTTNG_NTIRPC")
    set(USE_LTTNG_NTIRPC OFF)
  endif(LTTNG_FOUND)
else(USE_LTTNG)
  set(USE_LTTNG_NTIRPC OFF)
endif(USE_LTTNG)

find_library(LIBURCU_LIB urcu-bp)
find_path(LIBURCU_INC urcu-bp.h)
include_directories(${LIBURCU_INC})
set(SYSTEM_LIBRARIES ${SYSTEM_LIBRARIES} ${LIBURCU_LIB})

# Choose a shortcut build config

IF(BUILD_CONFIG)
  INCLUDE(
  ${CMAKE_SOURCE_DIR}/cmake/build_configurations/${BUILD_CONFIG}.cmake)
ENDIF()

# Build source locations and parameters

set(ALLOCATOR "jemalloc" CACHE STRING
  "specify the memory allocator to use: jemalloc|tcmalloc|libc")

# Find packages and libs we need for building
include(CheckIncludeFiles)
include(TestBigEndian)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(LINUX ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD|Darwin")
  set(BSDBASED ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD|Darwin")

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set(WINDOWS ON)
  if(${CMAKE_CXX_COMPILER_ID} MATCHES "MSVC")
    set(MSVC ON)
  endif(${CMAKE_CXX_COMPILER_ID} MATCHES "MSVC")
endif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

check_include_files(stdbool.h HAVE_STDBOOL_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(string.h HAVE_STRING_H)

TEST_BIG_ENDIAN(BIGENDIAN)
if(${BIGENDIAN})
  set(WORDS_BIGENDIAN ON)
else()
  set(WORDS_BIGENDIAN OFF)
endif(${BIGENDIAN})

find_package(Threads REQUIRED)
find_package(EPOLL REQUIRED)
set(TIRPC_EPOLL ${EPOLL_FOUND})
find_package(Sanitizers)

if(_MSPAC_SUPPORT)
  find_package(WBclient REQUIRED)
  set(SYSTEM_LIBRARIES ${WBclient_LIBRARIES} ${SYSTEM_LIBRARIES})
endif(_MSPAC_SUPPORT)

if (BSDBASED)
   set(EXTRA_INCLUDE_DIR "/opt/ganesha/include")
else()
  # workaround bug in some include_directories when no extra includes
  set(EXTRA_INCLUDE_DIR "${NTIRPC_BASE_DIR}/ntirpc/")
endif(BSDBASED)

add_definitions(-DHAVE_CONFIG_H)

if (MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

include_directories(BEFORE
  "${PROJECT_BINARY_DIR}"
  "${NTIRPC_BASE_DIR}/ntirpc/"
  "${EXTRA_INCLUDE_DIR}"
)

set(SYSTEM_LIBRARIES
  ${LIBTIRPC_LIBRARIES}
  ${KRB5_LIBRARIES}
  ${SYSTEM_LIBRARIES}
)

if (NOT BSDBASED)
  find_package(NSL) # sockets
  set(SYSTEM_LIBRARIES
    ${SYSTEM_LIBRARIES}
    ${NSL_LIBRARY}
  )
endif (NOT BSDBASED)

set(LIBNTIRPC_MAP "${PROJECT_BINARY_DIR}/src/libntirpc.map")
# subst files (need add_custom_command for dependency, fyi)
configure_file(
  "${NTIRPC_BASE_DIR}/src/libntirpc.map.in.cmake"
  "${PROJECT_BINARY_DIR}/libntirpc.map"
)

add_subdirectory(src)
add_subdirectory(tests)

# display configuration vars

message(STATUS)
message(STATUS "-------------------------------------------------------")
message(STATUS "TIRPC_EPOLL = ${TIRPC_EPOLL}")
message(STATUS "USE_RPC_RDMA = ${USE_RPC_RDMA}")
message(STATUS "USE_GSS = ${USE_GSS}")
message(STATUS "USE_PROFILE = ${USE_PROFILE}")
message(STATUS "USE_LTTNG_NTIRPC = ${USE_LTTNG_NTIRPC}")

#force command line options to be stored in cache
set(_MSPAC_SUPPORT ${_MSPAC_SUPPORT}
  CACHE BOOL
   "compile with MSPAC extensions"
   FORCE)

set(TIRPC_EPOLL ${TIRPC_EPOLL}
  CACHE BOOL
   "platform has EPOLL or emulation"
   FORCE)

# grist files
configure_file(
  "${NTIRPC_BASE_DIR}/config-h.in.cmake"
  "${PROJECT_BINARY_DIR}/config.h"
)

configure_file(
  "${NTIRPC_BASE_DIR}/version-h.in.cmake"
  "${PROJECT_BINARY_DIR}/ntirpc/version.h"
)

configure_file(
  "${NTIRPC_BASE_DIR}/libntirpc.pc.in.cmake"
  "${PROJECT_BINARY_DIR}/libntirpc.pc"
  @ONLY
)

configure_file(
  "${NTIRPC_BASE_DIR}/libntirpc.spec-in.cmake"
  "${PROJECT_SOURCE_DIR}/libntirpc.spec"
)

if (NOT TARGET dist)
set(CPACK_COMPONENT_DAEMON_DISPLAY_NAME "libntirpc")

# Include custom config and cpack module
include(${CMAKE_SOURCE_DIR}/cmake/cpack_config.cmake)
include(CPack)

set( PKG_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}.tar.gz")
	add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
endif (NOT TARGET dist)

if (NOT TARGET rpm)
add_custom_target( rpm DEPENDS dist)
add_custom_command(TARGET rpm
                  COMMAND sh -c "rpmbuild -ta ${PKG_NAME}"
		  VERBATIM
		  DEPENDS dist)

set(RPMDEST "--define '_srcrpmdir ${CMAKE_CURRENT_BINARY_DIR}'")
add_custom_target( srpm DEPENDS dist)
add_custom_command(TARGET srpm
                  COMMAND sh -c "rpmbuild ${RPMDEST} -ts ${PKG_NAME}"
		  VERBATIM
		  DEPENDS dist)
endif (NOT TARGET rpm)
########### install files ###############

install(FILES  ${PROJECT_BINARY_DIR}/libntirpc.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
install(DIRECTORY  ${NTIRPC_BASE_DIR}/ntirpc DESTINATION include)
install(FILES  ${PROJECT_BINARY_DIR}/ntirpc/version.h DESTINATION include/ntirpc)

=== debian/changelog ===
ntirpc (5.8-2~bpo12+1) bookworm-backports; urgency=medium

  * bookworm backport rebuild
  * build depends on dpkg-dev changed to bookworm version

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 04 Oct 2024 12:01:49 +0200

ntirpc (5.8-2) unstable; urgency=medium

  * rebuild for unstable
  * remove onlyjob@debian.org as Maintainer
  * bump standards-version (no changes)

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 26 Aug 2024 11:40:12 +0200

ntirpc (5.8-1) experimental; urgency=medium

  * New upstream version 5.8

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 05 Aug 2024 21:48:57 +0200

ntirpc (4.3-4) unstable; urgency=medium

  * add Build-Depends on libnsl-dev (closes: #1066943)
  * fix clean target
  * wrap-and-sort debian/control

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 21 Mar 2024 16:01:05 +0100

ntirpc (4.3-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063214

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 01:23:43 +0000

ntirpc (4.3-3) unstable; urgency=medium

  * fix missing assert.h include (closes: #1042047)

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 29 Aug 2023 09:26:01 +0200

=== debian/control ===
Source: ntirpc
Section: net
Priority: optional
Maintainer: Christoph Martin <martin@uni-mainz.de>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dpkg-dev (>= 1.21.22),
 libkrb5-dev,
 libnsl-dev,
 liburcu-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/nfs-ganesha/ntirpc
Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
Vcs-Browser: https://salsa.debian.org/debian/libntirpc

Package: libntirpc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libntirpc5.8 (= ${binary:Version}),
 ${misc:Depends},
Description: new transport-independent RPC library - development files
 Port of Sun's transport-independent RPC library to Linux. The library
 is intended as a replacement for the RPC code in the GNU C library,
 providing among others support for RPC (and in turn, NFS) over IPv6.
 .
 Changes introduced in the ntirpc library include:
  * Bi-directional operation.
  * Full-duplex operation on the TCP (vc) transport.
  * Thread-safe operating modes:
    * new locking primitives and lock callouts (interface change).
    * stateless send/recv on the TCP transport (interface change).
  * Flexible server integration support.
  * Event channels.
 .
 This package provides development files.

Package: libntirpc5.8
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libtirpc-common,
 ${misc:Depends},
 ${shlibs:Depends},
Description: new transport-independent RPC library
 Port of Sun's transport-independent RPC library to Linux. The library
 is intended as a replacement for the RPC code in the GNU C library,
 providing among others support for RPC (and in turn, NFS) over IPv6.
 .
 Changes introduced in the ntirpc library include:
  * Bi-directional operation.
  * Full-duplex operation on the TCP (vc) transport.
  * Thread-safe operating modes:
    * new locking primitives and lock callouts (interface change).
    * stateless send/recv on the TCP transport (interface change).
  * Flexible server integration support.
  * Event channels.

=== debian/watch ===
version=4
opts="mode=git, compression=gzip" \
 https://github.com/nfs-ganesha/ntirpc.git \
 refs/tags/[Vv]?(\d[\d\.]+) debian uupdate
# https://github.com/nfs-ganesha/ntirpc/releases \
#  .*/archive/[Vv]?(\d[\d\.]+)\.tar\.(?:gz|bz2|xz)

## ntirpc 6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,9 +13,9 @@
 project(NTIRPC C)
 
 # version numbers
-set(NTIRPC_MAJOR_VERSION 5)
+set(NTIRPC_MAJOR_VERSION 6)
 # This is .0 for a release, .N for a stable branch, blank for development
-set(NTIRPC_MINOR_VERSION .8)
+set(NTIRPC_MINOR_VERSION .3)
 # -something for dev releases
 set(NTIRPC_VERSION_EXTRA )
 set(VERSION_COMMENT
@@ -104,9 +104,45 @@
   # if your LTTng is not in a standard place
   find_package(LTTng REQUIRED)
   if(LTTNG_FOUND)
-    include_directories(${LTTNG_INCLUDE_DIR})
+
+    if(NOT CMAKE_EXPORT_COMPILE_COMMANDS)
+      # We must create compile_commands.json for lttng trace generation
+      set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
+    endif(NOT CMAKE_EXPORT_COMPILE_COMMANDS)
+
+    set(CMAKE_C_STANDARD_INCLUDE_DIRECTORIES ${CMAKE_C_IMPLICIT_INCLUDE_DIRECTORIES})
+
+    execute_process(
+	COMMAND ${CMAKE_COMMAND} -E make_directory
+		"${CMAKE_CURRENT_BINARY_DIR}/ntirpc_generated_include/lttng/generated_traces"
+	COMMAND_ERROR_IS_FATAL ANY
+    )
+
+    include_directories(
+      ${LTTNG_INCLUDE_DIR}
+      "${CMAKE_CURRENT_SOURCE_DIR}/src/lttng/generator/include/"
+      "${CMAKE_CURRENT_BINARY_DIR}/ntirpc_generated_include/"
+    )
+
     set(USE_LTTNG_NTIRPC ON)
     set(BINARY_LIBRARIES ${BINARY_LIBRARIES} ntirpc_lttng)
+
+    execute_process(
+      COMMAND bash -c "${CMAKE_CURRENT_SOURCE_DIR}/src/lttng/generator/generate_cmake_rules.py \
+          --project_path ${CMAKE_CURRENT_SOURCE_DIR} \
+          --provider_include_base_path lttng/generated_traces/ \
+          --unique_prefix ntirpc \
+          --filter_out src/lttng/generator \
+          --traces_output_dir ${CMAKE_CURRENT_BINARY_DIR}/ntirpc_generated_include/lttng/generated_traces/ \
+          --include_path ${CMAKE_CURRENT_SOURCE_DIR}/ntirpc:${CMAKE_CURRENT_SOURCE_DIR}/src/lttng/generator/include/:${CMAKE_CURRENT_BINARY_DIR}/ntirpc_generated_include/ \
+          --targets_output_path ${CMAKE_CURRENT_BINARY_DIR}/ntirpc_lttng_generation_rules.cmake \
+          --file_properties_output_path ${CMAKE_CURRENT_BINARY_DIR}/ntirpc_lttng_generation_file_properties.cmake"
+
+      COMMAND_ERROR_IS_FATAL ANY
+    )
+
+    include("${CMAKE_CURRENT_BINARY_DIR}/ntirpc_lttng_generation_rules.cmake")
+    include("${CMAKE_CURRENT_BINARY_DIR}/ntirpc_lttng_generation_file_properties.cmake")
   else(LTTNG_FOUND)
     message(WARNING "LTTng libraries not found. Disabling USE_LTTNG_NTIRPC")
     set(USE_LTTNG_NTIRPC OFF)

=== src/CMakeLists.txt ===

add_definitions(
  -DPORTMAP
  -DINET6
  -D_GNU_SOURCE
)

# ok on Linux and FreeBSD w/GCC and clang compilers
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

########### next target ###############

SET(ntirpc_common_SRCS
  auth_none.c
  auth_unix.c
  authunix_prot.c
  bindresvport.c
  bsd_epoll.c
  city.c
  clnt_bcast.c
  clnt_dg.c
  clnt_generic.c
  clnt_perror.c
  clnt_raw.c
  clnt_simple.c
  clnt_vc.c
  getnetconfig.c
  getnetpath.c
  getpeereid.c
  getrpcent.c
  mt_misc.c
  pmap_prot.c
  pmap_prot2.c
  pmap_rmt.c
  rbtree.c
  rbtree_x.c
  rpc_prot.c
  rpc_callmsg.c
  rpc_commondata.c
  rpc_crc32.c
  rpc_dplx_msg.c
  rpc_dtablesize.c
  rpc_generic.c
  rpcb_clnt.c
  rpcb_prot.c
  rpcb_st_xdr.c
  strlcpy.c
  svc.c
  svc_auth.c
  svc_auth_unix.c
  svc_auth_none.c
  svc_dg.c
  svc_generic.c
  svc_raw.c
  svc_rqst.c
  svc_simple.c
  svc_vc.c
  svc_xprt.c
  xdr.c
  xdr_float.c
  xdr_mem.c
  xdr_reference.c
  xdr_ioq.c
  svc_ioq.c
  work_pool.c
)

if(USE_GSS)
  SET(ntirpc_gss_SRCS
    auth_gss.c authgss_hash.c
    authgss_prot.c
    svc_auth_gss.c
    )

  # fixme
  # libntirpc_la_LDFLAGS += $(GSSGLUE_LIBS)
  # libntirpc_la_CFLAGS = -DHAVE_RPCSEC_GSS $(GSSGLUE_CFLAGS)

endif(USE_GSS)

if(USE_RPC_RDMA)
  SET(ntirpc_rdma_SRCS
  clnt_rdma.c
  rpc_rdma.c
  svc_rdma.c
  xdr_rdma.c
  )
endif(USE_RPC_RDMA)

if(USE_LTTNG_NTIRPC)
  include("${CMAKE_CURRENT_BINARY_DIR}/../ntirpc_lttng_generation_file_properties.cmake")
  add_subdirectory(lttng)
endif(USE_LTTNG_NTIRPC)

# declares the library
add_library(ntirpc SHARED
  ${ntirpc_common_SRCS}
  ${ntirpc_gss_SRCS}
  ${ntirpc_rdma_SRCS}
)

# add required libraries--for Ganesha build, it's ok for them to
# propagate (i.e., omit PRIVATE)
target_link_libraries(ntirpc ${SYSTEM_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

if(USE_LTTNG)
target_link_libraries(ntirpc ntirpc_lttng)
endif(USE_LTTNG)

# set library version and symbol namespace(s) from gen'd map file
set_target_properties(ntirpc PROPERTIES LINK_FLAGS
	"-Wl,--version-script=${PROJECT_BINARY_DIR}/libntirpc.map"
  VERSION ${NTIRPC_VERSION}
  SOVERSION "${NTIRPC_MAJOR_VERSION}${NTIRPC_MINOR_VERSION}"
  )

install(TARGETS ntirpc DESTINATION ${LIB_INSTALL_DIR})

########### install files ###############

# We are still missing the install of docs and stuff

=== tests/CMakeLists.txt ===

SET(rpcping_SRCS
  rpcping.c
  )
add_executable(rpcping ${rpcping_SRCS})
target_link_libraries(rpcping ntirpc
  ${BINARY_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  ${LTTNG_LIBRARIES}
  -ldl)

if(USE_LTTNG)
target_link_libraries(rpcping ntirpc_lttng)
include("${CMAKE_CURRENT_BINARY_DIR}/../ntirpc_lttng_generation_file_properties.cmake")
endif(USE_LTTNG)

=== src/lttng/CMakeLists.txt ===
add_subdirectory(generator ${CMAKE_CURRENT_SOURCE_DIR}/generator/build)

include_directories(
  ${LTTNG_INCLUDE_DIR}
)

set(ntirpc_tracepoints_LIB_SRCS
  lttng_probes.c
)

add_library(ntirpc_tracepoints MODULE ${ntirpc_tracepoints_LIB_SRCS})
#add_sanitizers(ntirpc_tracepoints)

target_link_libraries(ntirpc_tracepoints
  ${LTTNG_LIBRARIES}
)

add_dependencies(ntirpc_tracepoints ntirpc_generate_lttng_trace_headers)

set_target_properties(ntirpc_tracepoints PROPERTIES
  VERSION ${NTIRPC_VERSION}
  SOVERSION "${NTIRPC_MAJOR_VERSION}${NTIRPC_MINOR_VERSION}"
)

install(TARGETS ntirpc_tracepoints COMPONENT tracing DESTINATION ${LIB_INSTALL_DIR} )

add_library(ntirpc_lttng STATIC lttng_defines.c)
#add_sanitizers(ntirpc_lttng)

target_link_libraries(ntirpc_lttng
  ${LTTNG_LIBRARIES}
)

add_dependencies(ntirpc_lttng ntirpc_generate_lttng_trace_headers)

=== src/lttng/generator/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

project(generate_lttng LANGUAGES C CXX)

set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_STANDARD_INCLUDE_DIRECTORIES ${CMAKE_C_IMPLICIT_INCLUDE_DIRECTORIES})


find_package(LLVM REQUIRED CONFIG)
find_package(Clang REQUIRED CONFIG)
separate_arguments(LLVM_DEFINITIONS_LIST NATIVE_COMMAND ${LLVM_DEFINITIONS})

add_library(generate_lttng generate_lttng.cpp)
target_include_directories(generate_lttng PRIVATE ${LLVM_INCLUDE_DIRS})
target_compile_definitions(generate_lttng PRIVATE ${LLVM_DEFINITIONS_LIST})
target_link_libraries(generate_lttng
    LLVM
    clang-cpp
    stdc++fs
)

add_executable(generate_lttng_for_files generate_lttng_for_files.cpp)
add_executable(generate_lttng_for_project generate_lttng_for_project.cpp)

target_include_directories(generate_lttng_for_files PRIVATE ${LLVM_INCLUDE_DIRS})
target_compile_definitions(generate_lttng_for_files PRIVATE ${LLVM_DEFINITIONS_LIST})

target_link_libraries(generate_lttng_for_files
    generate_lttng
    LLVM
    clang-cpp
    stdc++fs
)

target_include_directories(generate_lttng_for_project PRIVATE ${LLVM_INCLUDE_DIRS})
target_compile_definitions(generate_lttng_for_project PRIVATE ${LLVM_DEFINITIONS_LIST})

target_link_libraries(generate_lttng_for_project
    generate_lttng
    LLVM
    clang-cpp
    stdc++fs
)

target_compile_options(generate_lttng_for_files PRIVATE "-Wall" "-Werror")
target_compile_options(generate_lttng_for_project PRIVATE "-Wall" "-Werror")

add_subdirectory(test)

# We create a library to compile failure test code
# We need to compile it so it has compile commands that can be used by the test
add_library(failure_tests STATIC EXCLUDE_FROM_ALL
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_too_many_arguments.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_too_many_arguments_with_arrays.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_too_many_arguments_for_format.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_not_enough_arguments_for_format.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_invalid_format1.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_invalid_format2.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_invalid_format3.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_invalid_format4.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_unsupported_struct.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_unsupported_typedef_struct.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_unsupported_union.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_missing_log_level.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_missing_log_format.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_bad_fnc_format.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_has_side_effects_func_call.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_has_side_effects_func_expression.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_has_side_effects_inc.c
    ${CMAKE_CURRENT_SOURCE_DIR}/failure_tests/test_code_failure_has_side_effects_volatile.c
)
target_compile_options(failure_tests PRIVATE "-DLTTNG_PARSING")
target_include_directories(failure_tests PRIVATE
    include
    test
    ${LTTNGUST_INCLUDE_DIRS}
)

# Create symlinks for executables that need to be used by the test
execute_process(
    COMMAND ${CMAKE_COMMAND} -E create_symlink
        ${CMAKE_CURRENT_BINARY_DIR}/generate_lttng_for_files
        ${CMAKE_CURRENT_SOURCE_DIR}/generate_lttng_for_files
)

# Create symlink for compile commands
if(NOT ${CMAKE_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
    execute_process(
        COMMAND ${CMAKE_COMMAND} -E create_symlink
            ${CMAKE_BINARY_DIR}/compile_commands.json
            ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif(NOT ${CMAKE_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})

# Run tests at the end of the build
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ran_tests
     COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test/run_tests.sh ${} && touch ${CMAKE_CURRENT_BINARY_DIR}/ran_tests
     DEPENDS generate_lttng_for_files generate_lttng_for_project test_bin
     COMMENT "Run tests"
)

add_custom_target(tests_target
     ALL
     DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/ran_tests
)

=== src/lttng/generator/test/CMakeLists.txt ===
execute_process(
	COMMAND ${CMAKE_COMMAND} -E make_directory
		"${CMAKE_CURRENT_BINARY_DIR}/generated_include/auto"
	COMMAND_ERROR_IS_FATAL ANY
)

# Generate build rules for generated test traces
execute_process(
    COMMAND bash -c "${CMAKE_CURRENT_SOURCE_DIR}/../generate_cmake_rules.py \
        --project_path ${CMAKE_CURRENT_SOURCE_DIR} \
        --provider_include_base_path auto/ \
        --traces_output_dir ${CMAKE_CURRENT_SOURCE_DIR}/auto/ \
        --targets_output_path ${CMAKE_CURRENT_BINARY_DIR}/lttng_generation_rules.cmake \
        --file_properties_output_path ${CMAKE_CURRENT_BINARY_DIR}/lttng_generation_file_properties.cmake"
    COMMAND_ERROR_IS_FATAL ANY
)

include("${CMAKE_CURRENT_BINARY_DIR}/lttng_generation_rules.cmake")
include("${CMAKE_CURRENT_BINARY_DIR}/lttng_generation_file_properties.cmake")

set(TestBinFiles
    test_code.c
    test_code2.c
    test_code-tp.c
)

add_executable(test_bin
    ${TestBinFiles}
)
add_dependencies(test_bin generate_lttng_trace_headers)
find_package(LTTngUST REQUIRED MODULE)

if(NOT ${LTTNGUST_FOUND})
message(FATAL_ERROR "LTTNG library not found")
endif(NOT ${LTTNGUST_FOUND})

target_link_libraries(test_bin
    LTTng::UST
)

target_include_directories(test_bin PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/
    "${CMAKE_CURRENT_BINARY_DIR}/generated_include/"
    ${LTTNGUST_INCLUDE_DIRS}
)

# Create symlinks for executables that need to be used by the test
execute_process(
    COMMAND ${CMAKE_COMMAND} -E create_symlink
        ${CMAKE_CURRENT_BINARY_DIR}/test_bin
        ${CMAKE_CURRENT_SOURCE_DIR}/test_bin
)

=== debian/changelog ===
ntirpc (6.3-3) unstable; urgency=medium

  [ Adrian Bunk ]
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1113333)

  [ Christoph Martin ]
  * Change to my Debian one email

 -- Christoph Martin <chrism@debian.org>  Tue, 28 Oct 2025 20:32:41 +0100

ntirpc (6.3-2) unstable; urgency=medium

  * rebuild for unstable

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 27 Jan 2025 10:36:19 +0100

ntirpc (6.3-1) experimental; urgency=medium

  * New upstream version 6.3
  * bump standards-version (no changes)

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 09 Jan 2025 21:20:45 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: ntirpc
 Section: net
 Priority: optional
-Maintainer: Christoph Martin <martin@uni-mainz.de>
+Maintainer: Christoph Martin <chrism@debian.org>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
- dpkg-dev (>= 1.21.22),
+ dpkg-dev (>= 1.22.5),
  libkrb5-dev,
  libnsl-dev,
  liburcu-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/nfs-ganesha/ntirpc
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
 Vcs-Browser: https://salsa.debian.org/debian/libntirpc
@@ -19,7 +19,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libntirpc5.8 (= ${binary:Version}),
+ libntirpc6.3 (= ${binary:Version}),
  ${misc:Depends},
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
@@ -37,7 +37,7 @@
  .
  This package provides development files.
 
-Package: libntirpc5.8
+Package: libntirpc6.3
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

#PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
#PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))

%:
	dh $@ --buildsystem=cmake


override_dh_auto_configure:
#	cp -vf CMakeLists.txt.standalone CMakeLists.txt
	dh_auto_configure --                          \
            -DCMAKE_VERBOSE_MAKEFILE=ON                \
            -DCMAKE_BUILD_TYPE=Release                  \
            -DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	    -DTIRPC_EPOLL=1 \
	    -DUSE_GSS=ON

override_dh_auto_clean:
	dh_auto_clean
	- rm libntirpc.spec

#override_dh_auto_test:
#	set -ex; \
#	cd obj-$(DEB_BUILD_GNU_TYPE); \
#	for i in raw rdma tcp udp; do \
#		./tests/rpcping $$i localhost --count=1000 --threads=4 --workers=2; \
#	done

#override_dh_auto_install:
#	dh_auto_install --destdir=$(CURDIR)/debian/tmp

#override_dh_auto_install:
#	dh_auto_install --destdir=debian/tmp
#	dh_install -ppython-eblob
#	dh_install -Xlibeblob_python.so

#override_dh_makeshlibs:
#	dh_makeshlibs -V

## ntirpc 7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,12 +10,12 @@
 
 include(${CMAKE_SOURCE_DIR}/cmake/maintainer_mode.cmake)
 
-project(NTIRPC C)
+project(NTIRPC C CXX)
 
 # version numbers
-set(NTIRPC_MAJOR_VERSION 6)
+set(NTIRPC_MAJOR_VERSION 7)
 # This is .0 for a release, .N for a stable branch, blank for development
-set(NTIRPC_MINOR_VERSION .3)
+set(NTIRPC_MINOR_VERSION .0)
 # -something for dev releases
 set(NTIRPC_VERSION_EXTRA )
 set(VERSION_COMMENT
@@ -77,6 +77,10 @@
   endif(KRB5_FOUND)
 endif (USE_GSS)
 
+option(USE_MONITORING "Enable monitoring stack" ON)
+
+option(PROXY_PROTOCOL_PARSE_COMMON_NETWORK_ID "Enable parsing of common network id from haproxy TLV" OFF)
+
 option(USE_RPC_RDMA "platform supports RDMA" OFF)
 if (USE_RPC_RDMA)
   find_package(RDMA REQUIRED)
@@ -260,6 +264,8 @@
 message(STATUS "USE_GSS = ${USE_GSS}")
 message(STATUS "USE_PROFILE = ${USE_PROFILE}")
 message(STATUS "USE_LTTNG_NTIRPC = ${USE_LTTNG_NTIRPC}")
+message(STATUS "USE_MONITORING = ${USE_MONITORING}")
+message(STATUS "PROXY_PROTOCOL_PARSE_COMMON_NETWORK_ID = ${PROXY_PROTOCOL_PARSE_COMMON_NETWORK_ID}")
 
 #force command line options to be stored in cache
 set(_MSPAC_SUPPORT ${_MSPAC_SUPPORT}

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,7 @@
   getpeereid.c
   getrpcent.c
   mt_misc.c
+  metrics_libntirpc.c
   pmap_prot.c
   pmap_prot2.c
   pmap_rmt.c
@@ -92,6 +93,12 @@
   add_subdirectory(lttng)
 endif(USE_LTTNG_NTIRPC)
 
+# Monitoring stack.
+LIST(APPEND CMAKE_LIBRARY_PATH "${CMAKE_CURRENT_SOURCE_DIR}/monitoring/")
+LINK_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}/monitoring/")
+include_directories("${CMAKE_CURRENT_SOURCE_DIR}/monitoring/include")
+add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/monitoring/")
+
 # declares the library
 add_library(ntirpc SHARED
   ${ntirpc_common_SRCS}
@@ -101,7 +108,11 @@
 
 # add required libraries--for Ganesha build, it's ok for them to
 # propagate (i.e., omit PRIVATE)
-target_link_libraries(ntirpc ${SYSTEM_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
+target_link_libraries(ntirpc
+  ${SYSTEM_LIBRARIES}
+  ${CMAKE_THREAD_LIBS_INIT}
+  ntirpcmonitoring
+)
 
 if(USE_LTTNG)
 target_link_libraries(ntirpc ntirpc_lttng)

=== src/monitoring/CMakeLists.txt ===
########### next target ###############

set(CMAKE_CXX_STANDARD 17)

SET(ntirpcmonitoring_SRCS
  monitoring.cc
)

add_library(ntirpcmonitoring SHARED ${ntirpcmonitoring_SRCS})
add_sanitizers(ntirpcmonitoring)
set_target_properties(ntirpcmonitoring PROPERTIES COMPILE_FLAGS "-fPIC"
  VERSION ${NTIRPC_VERSION}
  SOVERSION "${NTIRPC_MAJOR_VERSION}${NTIRPC_MINOR_VERSION}"
  )
target_include_directories(ntirpcmonitoring     PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/prometheus-cpp-lite/core/include)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic-errors -Werror -Wall -Wextra")
install(TARGETS ntirpcmonitoring DESTINATION ${LIB_INSTALL_DIR})

########### install files ###############

=== debian/changelog ===
ntirpc (7.0-3) unstable; urgency=medium

  * use pkgkde-symbolshelper to create arch dependent symbols files (2nd
    step) (closes: #1129210)

 -- Christoph Martin <chrism@debian.org>  Tue, 03 Mar 2026 10:53:48 +0100

ntirpc (7.0-2) unstable; urgency=medium

  * use pkgkde-symbolshelper to create arch dependent symbols files (1st
    step)

 -- Christoph Martin <chrism@debian.org>  Tue, 03 Mar 2026 00:20:42 +0100

ntirpc (7.0-1) unstable; urgency=medium

  * enable wrap-and-sort in gitlab-ci
  * wrap-and-sort debian/control
  * New upstream version 7.0
  * remove 0001-Shutdown-only-if-CLOSE-has-been-set-to-xprt-xp_flags.patch
  * build-depend on prometheus-cpp-lite
  * include monitoring.h
  * add patch headers

 -- Christoph Martin <chrism@debian.org>  Thu, 26 Feb 2026 14:26:55 +0100

ntirpc (6.3-4) unstable; urgency=medium

  * backport upstream fix which causes high CPU usage (MR from Florian
    Bezdeka @fbezdeka)

 -- Christoph Martin <chrism@debian.org>  Mon, 05 Jan 2026 22:35:48 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,14 @@
 Priority: optional
 Maintainer: Christoph Martin <chrism@debian.org>
 Build-Depends:
+ debhelper-compat (= 13),
+ dh-sequence-pkgkde-symbolshelper,
+ dpkg-dev (>= 1.22.5),
  cmake,
- debhelper-compat (= 13),
- dpkg-dev (>= 1.22.5),
  libkrb5-dev,
  libnsl-dev,
  liburcu-dev,
+ prometheus-cpp-lite,
 Standards-Version: 4.7.0
 Homepage: https://github.com/nfs-ganesha/ntirpc
 Vcs-Git: https://salsa.debian.org/debian/libntirpc.git
@@ -19,7 +21,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libntirpc6.3 (= ${binary:Version}),
+ libntirpc7.0 (= ${binary:Version}),
  ${misc:Depends},
 Description: new transport-independent RPC library - development files
  Port of Sun's transport-independent RPC library to Linux. The library
@@ -37,7 +39,7 @@
  .
  This package provides development files.
 
-Package: libntirpc6.3
+Package: libntirpc7.0
 Section: libs
 Architecture: any
 Multi-Arch: same
